/* Auto-generated by genmsg_java.py for file /opt/ros/fuerte/stacks/arm_navigation/arm_navigation_msgs/msg/SimplePoseConstraint.msg */

package ros.pkg.arm_navigation_msgs.msg;

import java.nio.ByteBuffer;

public class SimplePoseConstraint extends ros.communication.Message {
  static public final int HEADER_FRAME = 0;
  static public final int LINK_FRAME = 1;

  public ros.pkg.std_msgs.msg.Header header = new ros.pkg.std_msgs.msg.Header();
  public java.lang.String link_name = new java.lang.String();
  public ros.pkg.geometry_msgs.msg.Pose pose = new ros.pkg.geometry_msgs.msg.Pose();
  public ros.pkg.geometry_msgs.msg.Point absolute_position_tolerance = new ros.pkg.geometry_msgs.msg.Point();
  public double absolute_roll_tolerance;
  public double absolute_yaw_tolerance;
  public double absolute_pitch_tolerance;
  public int orientation_constraint_type;

  public SimplePoseConstraint() {
  }

  public static java.lang.String __s_getDataType() { return "arm_navigation_msgs/SimplePoseConstraint"; }
  public java.lang.String getDataType() { return __s_getDataType(); }
  public static java.lang.String __s_getMD5Sum() { return "3483d830eb84ecd3059741fd417b30da"; }
  public java.lang.String getMD5Sum() { return __s_getMD5Sum(); }
  public static java.lang.String __s_getMessageDefinition() { return "# This message contains the definition of a simple pose constraint \n" +
"# that specifies the pose for a particular link of the robot and corresponding\n" +
"# (absolute) position and orientation tolerances\n" +
"\n" +
"# The standard ROS message header\n" +
"Header header\n" +
"\n" +
"# The robot link this constraint refers to\n" +
"string link_name\n" +
"\n" +
"# The desired position of the robot link\n" +
"geometry_msgs/Pose pose\n" +
"\n" +
"# Position (absolute) tolerance\n" +
"geometry_msgs/Point absolute_position_tolerance\n" +
"\n" +
"# Orientation (absolute) tolerance\n" +
"float64 absolute_roll_tolerance\n" +
"float64 absolute_yaw_tolerance\n" +
"float64 absolute_pitch_tolerance\n" +
"\n" +
"int32 orientation_constraint_type\n" +
"int32 HEADER_FRAME=0\n" +
"int32 LINK_FRAME=1\n" +
"\n" +
"================================================================================\n" +
"MSG: std_msgs/Header\n" +
"# Standard metadata for higher-level stamped data types.\n" +
"# This is generally used to communicate timestamped data \n" +
"# in a particular coordinate frame.\n" +
"# \n" +
"# sequence ID: consecutively increasing ID \n" +
"uint32 seq\n" +
"#Two-integer timestamp that is expressed as:\n" +
"# * stamp.secs: seconds (stamp_secs) since epoch\n" +
"# * stamp.nsecs: nanoseconds since stamp_secs\n" +
"# time-handling sugar is provided by the client library\n" +
"time stamp\n" +
"#Frame this data is associated with\n" +
"# 0: no frame\n" +
"# 1: global frame\n" +
"string frame_id\n" +
"\n" +
"================================================================================\n" +
"MSG: geometry_msgs/Pose\n" +
"# A representation of pose in free space, composed of postion and orientation. \n" +
"Point position\n" +
"Quaternion orientation\n" +
"\n" +
"================================================================================\n" +
"MSG: geometry_msgs/Point\n" +
"# This contains the position of a point in free space\n" +
"float64 x\n" +
"float64 y\n" +
"float64 z\n" +
"\n" +
"================================================================================\n" +
"MSG: geometry_msgs/Quaternion\n" +
"# This represents an orientation in free space in quaternion form.\n" +
"\n" +
"float64 x\n" +
"float64 y\n" +
"float64 z\n" +
"float64 w\n" +
"\n" +
""; }
  public java.lang.String getMessageDefinition() { return __s_getMessageDefinition(); }

  public SimplePoseConstraint clone() {
    SimplePoseConstraint c = new SimplePoseConstraint();
    c.deserialize(serialize(0));
    return c;
  }

  public void setTo(ros.communication.Message m) {
    deserialize(m.serialize(0));
  }

  public int serializationLength() {
    int __l = 0;
    __l += header.serializationLength();
    __l += 4 + link_name.length();
    __l += pose.serializationLength();
    __l += absolute_position_tolerance.serializationLength();
    __l += 8; // absolute_roll_tolerance
    __l += 8; // absolute_yaw_tolerance
    __l += 8; // absolute_pitch_tolerance
    __l += 4; // orientation_constraint_type
    return __l;
  }

  public void serialize(ByteBuffer bb, int seq) {
    header.serialize(bb, seq);
    Serialization.writeString(bb, link_name);
    pose.serialize(bb, seq);
    absolute_position_tolerance.serialize(bb, seq);
    bb.putDouble(absolute_roll_tolerance);
    bb.putDouble(absolute_yaw_tolerance);
    bb.putDouble(absolute_pitch_tolerance);
    bb.putInt(orientation_constraint_type);
  }

  public void deserialize(ByteBuffer bb) {
    header.deserialize(bb);
    link_name = Serialization.readString(bb);
    pose.deserialize(bb);
    absolute_position_tolerance.deserialize(bb);
    absolute_roll_tolerance = bb.getDouble();
    absolute_yaw_tolerance = bb.getDouble();
    absolute_pitch_tolerance = bb.getDouble();
    orientation_constraint_type = bb.getInt();
  }

  @SuppressWarnings("all")
  public boolean equals(Object o) {
    if(!(o instanceof SimplePoseConstraint))
      return false;
    SimplePoseConstraint other = (SimplePoseConstraint) o;
    return
      header.equals(other.header) &&
      link_name.equals(other.link_name) &&
      pose.equals(other.pose) &&
      absolute_position_tolerance.equals(other.absolute_position_tolerance) &&
      absolute_roll_tolerance == other.absolute_roll_tolerance &&
      absolute_yaw_tolerance == other.absolute_yaw_tolerance &&
      absolute_pitch_tolerance == other.absolute_pitch_tolerance &&
      orientation_constraint_type == other.orientation_constraint_type &&
      true;
  }

  @SuppressWarnings("all")
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    long tmp;
    result = prime * result + (this.header == null ? 0 : this.header.hashCode());
    result = prime * result + (this.link_name == null ? 0 : this.link_name.hashCode());
    result = prime * result + (this.pose == null ? 0 : this.pose.hashCode());
    result = prime * result + (this.absolute_position_tolerance == null ? 0 : this.absolute_position_tolerance.hashCode());
    result = prime * result + (int)((tmp = Double.doubleToLongBits(this.absolute_roll_tolerance)) ^ (tmp >>> 32));
    result = prime * result + (int)((tmp = Double.doubleToLongBits(this.absolute_yaw_tolerance)) ^ (tmp >>> 32));
    result = prime * result + (int)((tmp = Double.doubleToLongBits(this.absolute_pitch_tolerance)) ^ (tmp >>> 32));
    result = prime * result + this.orientation_constraint_type;
    return result;
  }
} // class SimplePoseConstraint

