import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintStream;


/**
 * Placeholder for the Player server interface that realizes the interaction with the PipeServer through
 * a pipe. Spwans a PipeServer and passes all data entered via stdin to it, reading results from it and 
 * writing them to stdout.  
 * @author jain
 *
 */
public class ShellClient {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
			Process p = Runtime.getRuntime().exec("java -cp /usr/wiss/jain/work/code/SRLDB/bin PipeServer");
			BufferedReader fromProbCog = new BufferedReader(new InputStreamReader(p.getInputStream()));
			BufferedReader fromProbCogErr = new BufferedReader(new InputStreamReader(p.getErrorStream()));
			PrintStream toProbCog = new PrintStream(p.getOutputStream());
			while(true) {
				while(fromProbCogErr.ready()) {
					System.out.println("Server:Status: " + fromProbCogErr.readLine());					
				}
				while(fromProbCog.ready()) {
					System.out.println("Server:Result: " + fromProbCog.readLine());					
				}
				if(br.ready()) {
					String line = br.readLine();				
					toProbCog.println(line);
					toProbCog.flush();
				}
			}
		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}
}
